
Core - Bug # 39904

Status: Resolved Priority: Must have
Author: internezzo ag Category: File Abstraction Layer (FAL)
Created: 2012-08-17 Assigned To: Steffen Ritter
Updated: 2012-11-20 Due date:
TYPO3 Version: 6.0
PHP Version:
Complexity:
Is Regression:
Sprint Focus:
Subject: Unresized image not displayed in FE after move in filelist
Description

When an image is moved in the filelist which is used unresized in a content element (CE), the wrong path is used in the FE.
Steps to reproduce:
    1. Create folder test1 and test2 and upload an image to test1
    2. Create CE with type image and integrate the image
    3. Check FE: image is directly linked to fileadmin/user_upload/test1/image.jpg
    4. Move image to test2 folder in filelist
    5. Clear cache / reindex FAL with scheduler task
    6. Check FE: image is still linked to test1 folder --> image is not displayed
    7. Edit CE: resize image
    8. Check FE: image is displayed correctly from processed folder
    9. Move image back and forth: FE remains intact as long as the image is resized

Related issues:
related to Core - Bug # 40033: Relation lost after renaming folder Resolved 2012-08-21
related to Core - Bug # 40669: FAL files get reindexed in storage null when u... Resolved 2012-09-06
blocked by Core - Bug # 43059: File processing is broken Resolved 2012-11-17

Associated revisions
Revision 66c204f0 - 2012-11-20 23:08 - Andreas Wolf 

[TASK] Refactor FAL file processing

File processing is a central part of TYPO3's file usage, as e.g. all
images in content elements have to be resized when they don't fit the
requirements. However, the current implementation of file processing
with FAL has several drawbacks and shortcomings, not to mention quite a
few bugs.

This patch brings a completely reworked infrastructure behind the
File Processing Service, while keeping the external API unchanged.

The processing to be done is described in tasks, which are part of a
ProcessedFile's properties. The processing itself is now moved to
processors, which could execute the tasks using different utilities,
e.g. ImageMagick or some cloud image processing service. Currently,
there is only a local image processor implementation, which relies on
ImageMagick/GraphicsMagick (i.e. uses the same configuration as the old
processing).
The processed file class now also supports safe handling of unchanged
files, i.e. files that should have been processed, but didn't need
processing.

Fixes: #43059
Fixes: #39904
Fixes: #40033
Fixes: #40669
Releases: 6.0

Change-Id: I186a46f9923dacd98be655d72be2bd89b43866c2
Reviewed-on: http://review.typo3.org/14310
Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel

History
#1 - 2012-09-01 16:02 - Andreas Wolf
- Status changed from New to Needs Feedback

What I don't get from your description: Did you move the file manually or by using FAL methods? Because the former method might sometimes break
stuff, though we have taken some measures to ensure consistency of the file index; the latter should definitely not break anything. Maybe this issue is
related to #40033 - we'll have to check that.

#2 - 2012-09-01 17:33 - Marcel Burkhalter

I moved the file in the backend module filelist.

#3 - 2012-09-01 18:36 - Andreas Wolf

Ok. Could you check if the index record in sys_file is updated, i.e. if the identifier of the file is changed to .../test2/...? This should normally happen, but
maybe something is broken here.

#4 - 2012-09-01 18:55 - Andreas Wolf

Andreas Wolf wrote:

Ok. Could you check if the index record in sys_file is updated, i.e. if the identifier of the file is changed to .../test2/...? This should normally happen,
but maybe something is broken here.

Forget what I said here... I found the reason for this bug: Even for files where no processing is applied (because they don't have to be resized etc.), a
ProcessedFile object is created and linked to the content record. This record points to the original location of the file, but is not updated when the file is
moved. Thus the relation breaks.

A solution could be to simply not create the ProcessedFile altogether when a file is not changed. I don't know why it happens at all or why there is no
check if the file has been processed before creating the record...
#5 - 2012-09-01 18:55 - Andreas Wolf
- Category set to Frontend
- Status changed from Needs Feedback to Accepted
- Target version set to 6.0 final

#6 - 2012-09-01 18:55 - Andreas Wolf
- Project changed from File Abstraction Layer to Core
- Category changed from Frontend to Frontend
- Target version deleted (6.0 final)

#7 - 2012-09-01 18:55 - Andreas Wolf
- Category changed from Frontend to File Abstraction Layer (FAL)
- TYPO3 Version set to 6.0

#8 - 2012-09-03 15:00 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#9 - 2012-09-05 10:39 - Steffen Ritter
- Assigned To set to Steffen Ritter

#10 - 2012-09-05 10:41 - Steffen Ritter
- Target version set to 6.0.0-beta2

#11 - 2012-09-06 11:40 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#12 - 2012-09-07 15:02 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#13 - 2012-10-10 11:19 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#14 - 2012-10-10 15:48 - Steffen Ritter
- Status changed from Under Review to On Hold

processed files handling is completely in rewrite
#15 - 2012-10-12 20:39 - Gerrit Code Review
- Status changed from On Hold to Under Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#16 - 2012-10-20 15:27 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#17 - 2012-10-21 15:27 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#18 - 2012-10-21 17:31 - Steffen Ritter
- Target version changed from 6.0.0-beta2 to 6.0.0-RC1

#19 - 2012-11-10 16:08 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#20 - 2012-11-10 16:19 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#21 - 2012-11-10 21:42 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#22 - 2012-11-10 21:49 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#23 - 2012-11-14 16:58 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310
#24 - 2012-11-17 17:49 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#25 - 2012-11-20 23:02 - Gerrit Code Review

Patch set 21 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14310

#26 - 2012-11-20 23:30 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:66c204f0bf3e83d302e6a5f9e367ebda267a015e.
